function PlayerManager:damage_absorption()
	local total = 0

	for _, absorption in pairs(self._damage_absorption) do
		total = total + Application:digest_value(absorption, false)
	end

	--total = total + self:get_best_cocaine_damage_absorption()    have to use other means
	total = managers.modifiers:modify_value("PlayerManager:GetDamageAbsorption", total)

	return total
end


function PlayerManager:cocaine_damage_absorption_to_resist()
	local MAX = 48
	--Fix by Krimzin, far better
	local current = self:get_best_cocaine_damage_absorption(my_peer_id)
	local reduction = 1 - ((current / MAX) * 0.8)
	if reduction < 0.01 then
		reduction = 0.01
	end
	return reduction
end
--[[dank ya kuz
-- BRAND NEW SHINY FUNCTION TO REPLACE OVERKILL'S UH-OH
function PlayerManager:has_cocaine_stack_absorption_multiplier()
	if self:has_category_upgrade("player", "cocaine_stack_absorption_multiplier") then
		return 2
	else
		return 1
	end
end

function PlayerManager:get_best_cocaine_damage_absorption(my_peer_id)
	local data = self._global.synced_cocaine_stacks[my_peer_id] or {}
	local multiplier = self:has_cocaine_stack_absorption_multiplier() --replaced previous check which always returned 1
	local absorption = 0
	local best_peer_id = 0

	if self._global.synced_cocaine_stacks then
		local peer_absorption = nil

		for peer_id, data in pairs(self._global.synced_cocaine_stacks) do
			if peer_id == my_peer_id or data.in_use then
				peer_absorption = self:_get_cocaine_damage_absorption_from_data(data)

				if absorption < peer_absorption then
					best_peer_id = peer_id or best_peer_id
				end

				absorption = math.max(absorption, peer_absorption)
			end
		end
	end

	return absorption * multiplier, best_peer_id
end

function PlayerManager:get_cocaine_damage_absorption_from_peer_id(peer_id, multiplier_peer_id)
	local data = self._global.synced_cocaine_stacks[peer_id] or {}
	local absorption = self:_get_cocaine_damage_absorption_from_data(data)
	local data = self._global.synced_cocaine_stacks[multiplier_peer_id or peer_id] or {}
	local multiplier = self:has_cocaine_stack_absorption_multiplier() --replaced previous check which always returned 1, electric boogaloo

	return absorption * multiplier
end

function PlayerManager:get_peer_cocaine_damage_absorption_ratio(peer_id)
	local max_absorption = self:_get_best_max_cocaine_damage_absorption_ratio()
	local data = self._global.synced_cocaine_stacks[peer_id] or {}
	local multiplier = self:has_cocaine_stack_absorption_multiplier() --replaced previous check which always returned 1, the empire strikes back
	local absorption = self:_get_cocaine_damage_absorption_from_data(data) * multiplier

	return math.clamp(absorption / max_absorption, 0, 1)
end

function PlayerManager:get_peer_cocaine_damage_absorption_max_ratio(peer_id)
	local upgrade_tweak = tweak_data.upgrades
	local max_absorption = self:_get_best_max_cocaine_damage_absorption_ratio()
	local data = self._global.synced_cocaine_stacks[peer_id] or {}
	local upgrade_level = data.upgrade_level or 1
	local amount = upgrade_tweak.max_total_cocaine_stacks or 2047
	local multiplier = self:has_cocaine_stack_absorption_multiplier() --replaced previous check which always returned 1, final showdown
	local absorption = self:_get_cocaine_damage_absorption_from_data({
		amount = amount,
		upgrade_level = upgrade_level
	}) * multiplier

	return math.clamp(absorption / max_absorption, 0, 1)
end
]]--

--Damage Resist, finally
local dmgreduc_old_init = PlayerManager.damage_reduction_skill_multiplier
 
function PlayerManager:damage_reduction_skill_multiplier(damage_type)
    local multiplier = dmgreduc_old_init(self, damage_type)
	
	
	multiplier = multiplier * self:cocaine_damage_absorption_to_resist()
	
	return multiplier
end
--[[function PlayerManager:damage_reduction_skill_multiplier(damage_type)
	local multiplier = 1
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_outnumbered", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_outnumbered_strong", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_close_contact", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "revived_damage_resist", 1)
	multiplier = multiplier * self:upgrade_value("player", "damage_dampener", 1)
	multiplier = multiplier * self:upgrade_value("player", "health_damage_reduction", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "first_aid_damage_reduction", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "revive_damage_reduction", 1)
	multiplier = multiplier * self:get_hostage_bonus_multiplier("damage_dampener")
	multiplier = multiplier * self._properties:get_property("revive_damage_reduction", 1)
	multiplier = multiplier * self._temporary_properties:get_property("revived_damage_reduction", 1)
	--multiplier = multiplier * self:cocaine_damage_absorption_to_resist()
	local dmg_red_mul = self:team_upgrade_value("damage_dampener", "team_damage_reduction", 1)

	if self:has_category_upgrade("player", "passive_damage_reduction") then
		local health_ratio = self:player_unit():character_damage():health_ratio()
		local min_ratio = self:upgrade_value("player", "passive_damage_reduction")

		if health_ratio < min_ratio then
			dmg_red_mul = dmg_red_mul - (1 - dmg_red_mul)
		end
	end

	multiplier = multiplier * dmg_red_mul

	if damage_type == "melee" then
		multiplier = multiplier * managers.player:upgrade_value("player", "melee_damage_dampener", 1)
	end

	local current_state = self:get_current_state()

	if current_state and current_state:_interacting() then
		multiplier = multiplier * managers.player:upgrade_value("player", "interacting_damage_multiplier", 1)
	end

	return multiplier
end]]--